Strict
Import mojo

Global Debug$


Class WriteImageSample Extends App

   ' the buffers:
	Field TargetImage:Image, SourceImage:Image
	Field Buffer:Int[]
	
	'some flags for the demo:
	Field CopyNow%=0, CopyWhat%=0, Arc%, z1%, z2%, z3%
	Const READY%=0, DO_IT%=1, DONE%=2 
	Const RECT%=0, PICTURE%=1, MOVED%=2, TEXT%=3, TILES%=4
	
	Method OnCreate%()
		SetUpdateRate 60
		TargetImage=CreateImage(200,200)
		SourceImage=LoadImage("monkey64.png")
		Buffer = New Int[200 * 200]	
		Return 0
	End	
	
	Method OnUpdate%()
		If KeyHit(KEY_ESCAPE) Then Error ""
		If MouseHit(MOUSE_LEFT)
			If CopyNow=READY
				CopyWhat= CopyWhat Mod 4
				CopyNow=DO_IT
			Endif
		Elseif CopyNow=DONE
				CopyNow=READY
				CopyWhat=CopyWhat+1
		Endif
		
		Return 0
	End	
	
	
	
	Method OnRender%()
		Cls 
		If CopyNow=DO_IT
			CopyNow=DONE
			z1=Millisecs()			
			Select CopyWhat
				Case RECT
					' first sample combines 10 rect to one new image:
					For Local i%=0 To 10
						SetColor Rnd(0,255),Rnd(0,255),Rnd(0,255)
						DrawRect i*10,i*10, 180-i*10,140-i*10
					Next
					z2=Millisecs()			
					ReadPixels Buffer,0,0,200,200
					TargetImage.WritePixels Buffer,0,0,200,200


				Case PICTURE
					' second sample drwas a image 10 times then grab a new image:
					For Local i%=0 To 10
						DrawImage SourceImage,(i*45) Mod 200 ,i*20
					Next
					z2=Millisecs()			
					ReadPixels Buffer,0,0,200,200
					TargetImage.WritePixels Buffer,0,0,200,200


				Case MOVED
					' third sample grabbs an image an copies it 10 times to new image:
					' see the problems of background!
					SetColor 0,255,0
					DrawRect 0,0, 200,200
					SetColor 255,255,255
					ReadPixels Buffer,0,0,200,200
					TargetImage.WritePixels Buffer,0,0,200,200
					DrawImage SourceImage,0,0
					z2=Millisecs()			
					ReadPixels Buffer,0,0,200,200
					For Local i%=0 To 9
						TargetImage.WritePixels Buffer,(i*45) Mod 200,i*20,200,200
					Next


				Case TEXT
					' last sample shows the advantage of combining a lot of DrawTexts to one image:
					SetColor 255,255,0
					DrawText "Monkey is a Next-generation",0,0				
					DrawText "games programming language",0,13			
					DrawText "that allows you To create",0,26				
					DrawText "on multiple platforms with",0,39				
					DrawText "with the greatest of ease.",0,52				
					DrawText "Monkey works by translating",0,65				
					DrawText "Monkey code to one of a",0,78				
					DrawText "different number of languages",0,91				
					DrawText "at compile time - including",0,104				
					DrawText "C++, C#, Java, Javascript",0,117				
					DrawText "and Actionscript.",0,130				
					z2=Millisecs()			
					ReadPixels Buffer,0,0,200,200
					TargetImage.WritePixels Buffer,0,0,200,200


				End Select				
				z1=z2-z1		
				z2=Millisecs()-z2			
		Endif
		SetColor 255,255,255
		Local X%=Sin(Arc)*50
		Local Y%=Cos(Arc)*50
		Arc=Arc+1
		Translate 300,150
		z3=Millisecs()			
		DrawImage TargetImage,X,Y
		Debug="Draw old way: " + z1+ "msec         ReadPixel: " + z2 + "msec        Draw new way: " + (Millisecs()-z3)
		Translate -300,-150
		DrawText "Hit Mouse to switch Mode! Mode= " + CopyWhat, 0, 400
		DrawText "0=OFF, 1=CopyRectToImage, 2=CopyImageTo Image, 3=Moved Buffer, 4=RenderTextToImage", 0, 420
		SetColor 255,255,0
		DrawText "TIME RESULTS   " + Debug + "msec",0,440
		Return 0
	End	
	
End

Function Main%()
	New WriteImageSample
	Return 0
End
